#####################################
# General directories and libraries #
#####################################

GEN_INC_DIR=.
GEN_LIB_DIR=.
GEN_LIB= -gfortran -lm

####################################
# LAPACK directories and libraries #
####################################

LAPACK_LIB_DIR=/usr/lib
LAPACK_LIB= -llapack

###################################
# Atlas directories and libraries #
###################################

ATLAS_HOME=
ATLAS_INC_DIR=$(ATLAS_HOME)/usr/include
ATLAS_LIB_DIR=$(ATLAS_HOME)/usr/lib/atlas
ATLAS_LIB = -lcblas -lf77blas -latlas

###################################
# CPLEX directories and libraries #
###################################

CPLEX_HOME=/usr/ilog/cplex110
CPLEX_INC_DIR=$(CPLEX_HOME)/include/ilcplex
CPLEX_LIB_DIR=$(CPLEX_HOME)/lib/x86_rhel4.0_3.4/static_pic
CPLEX_LIB = -lcplex -lpthread

####################################
# Matlab directories and libraries #
####################################

MATLAB_HOME=/usr/local/matlab
MATLAB_INC_DIR=$(MATLAB_HOME)/extern/include
MATLAB_LIB_DIR=$(MATLAB_HOME)/bin/glnx86
MATLAB_LIB = -leng -lmx
MATLAB_ENGINE_COMMAND=matlab -nodesktop -nodisplay -nojvm -nosplash

## Do not edit below
## Do not edit below
## Do not edit below
## Do not edit below
## Do not edit below
## Do not edit below
## Do not edit below

######################################
# Combined directories and libraries #
######################################

INC_DIR = -I$(ATLAS_INC_DIR) -I$(CPLEX_INC_DIR) -I$(MATLAB_INC_DIR) -I$(GEN_INC_DIR)
LIB_DIR = -L$(LAPACK_LIB_DIR) -L$(ATLAS_LIB_DIR) -L$(CPLEX_LIB_DIR) -L$(MATLAB_LIB_DIR) -Wl,-R,$(MATLAB_LIB_DIR) -L$(GEN_LIB_DIR)
LIB = $(LAPACK_LIB) $(ATLAS_LIB) $(CPLEX_LIB) $(MATLAB_LIB) $(GEN_LIB)
